package com.example.application;

import com.vaadin.flow.component.orderedlayout.VerticalLayout;
import com.vaadin.flow.component.tabs.Tab;
import com.vaadin.flow.component.tabs.Tabs;
import com.vaadin.flow.router.ParentLayout;
import com.vaadin.flow.router.RouterLayout;
import com.vaadin.flow.router.RouterLink;

@ParentLayout(value = MainLayout.class)
public final class MainView extends VerticalLayout implements RouterLayout {

  private final Tabs tabs = new Tabs();
  private final Tab homeTab = new Tab(new RouterLink("Home", HomeView.class));
  private final Tab aboutTab = new Tab(new RouterLink("About", AboutView.class));

  public MainView() {
    super();

    tabs.add(homeTab, aboutTab);

    add(tabs);
  }

}
